local trap = nil
local mode = nil
local scope = "public" -- Set scope of the chat message (public or private)

function freeze_maybe_jail_user(player, yaw)
    trap = player:get_player_name()
    mode = "a"
    local pos = player:get_pos()
    pos.y = pos.y - 0.25
    minetest.add_entity(pos, "freeze:fe")
end

function unfreeze_user(player)
   mode = "d"
   trap = player:get_player_name()
end

minetest.register_entity("freeze:fe", {
    physical = false,
    collisionbox = {-0.00,-0.00,-0.00, 0.00,0.00,0.00},
    visual = "sprite",
    visual_size = {x=0, y=0},
    textures = {"freeze_t.png"},
    is_visible = true,
    makes_footstep_sound = false,

    on_activate = function(self, staticdata)
        self.object:set_armor_groups({immortal = 1})

        if not trap or not mode or self.trapped then
            return
        end

        local playerobj = minetest.get_player_by_name(trap)

        if not playerobj then
            return
        end

        if mode == "a" then
            local yaw = bed.userdata.saved[trap].spawn_yaw
            local yaw_in_degrees = (yaw + math.pi) / math.pi * 180
            minetest.chat_send_player(trap, ('%.02f %d'):format(yaw, yaw_in_degrees))
            playerobj:set_attach(self.object, "", {x=0,y=0,z=0}, {x=yaw_in_degrees,y=0,z=90})
		
            self.trapped = trap

            trap = nil
            mode = nil
        end
    end,

    on_step = function(self,dtime)
        if not trap or not mode then
            return
        end

        if mode == "d" and trap == self.trapped then
            local pobj = minetest.get_player_by_name(trap)

            if not pobj then
                return
            end

            pobj:set_detach()
            
            if scope == "public" then
                  minetest.chat_send_all("*** "..trap.." can move again.")
            else
                  minetest.chat_send_player(trap,"You can move now again.")
            end

            trap = nil
            mode = nil

            self.object:remove()
        end
    end,
})

minetest.register_on_leaveplayer(function(player)
    local ppos = player:get_pos()
    for _, obj in ipairs(minetest.get_objects_inside_radius(ppos, 2)) do
        obj:remove()
    end
end)
